<template>
  <v-container>
    <v-row>
      <v-col cols="2">
        <v-card-actions>
          <v-select
              :disabled="statusProgress"
              v-model="vendor"
              :items="vendors"
              label="Pilih Vendor"
              @change="doChangeVendor">
          </v-select>
        </v-card-actions>
      </v-col>
      <v-col cols="2">
        <v-card-actions>
          <v-radio-group
              v-model="checkType"
              column
              mandatory
              :disabled="statusProgress"
          >
            <v-radio
                label="Unregister ONT"
                value="UNREG"
            ></v-radio>
            <v-radio
                label="Register ONT"
                value="REG"
            ></v-radio>
            <v-radio
                label="Service ONT"
                value="SERVICE"
            ></v-radio>
          </v-radio-group>
        </v-card-actions>
      </v-col>
      <v-col cols="3">
        <v-card-text>
          <v-card-actions>
            <v-btn :disabled="statusProgress" @click="doProccess">Proccess</v-btn>
          </v-card-actions>
          <v-card-actions>
            <v-btn @click="showProgress" :disabled="statusProgress">Check Progress</v-btn>
          </v-card-actions>
        </v-card-text>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="6">
        <div v-if="items[0].children.length">
          <v-treeview
            v-model="selection"
            :items="items"
            item-disabled="locked"
            :selection-type="selectionType"
            selectable
            return-object
          ></v-treeview>
        </div>
        <div v-else>
          No node gpon.
        </div>
      </v-col>
      <v-divider vertical></v-divider>
      <v-col
          cols="6"
      >
        <div v-if="checkType === 'UNREG' && selection.length">
          <v-row v-for="gpon in selection" :key="gpon.id">
            <v-col cols="3">
              <v-text-field v-model="gpon.id" readonly label="IP GPON" />
            </v-col>
          </v-row>
        </div>
        <div v-if="checkType === 'REG' || checkType === 'SERVICE' && selection.length">
          <v-row v-for="gpon in selection" :key="gpon.id">
            <v-col cols="3">
              <v-text-field v-model="gpon.id" readonly label="IP GPON" />
            </v-col>
            <v-col cols="1">
              <v-text-field v-model="gpon.slot" label="Slot"/>
            </v-col>
            <v-col cols="1">
              <v-text-field v-model="gpon.port" label="Port"/>
            </v-col>
            <v-col cols="3">
              <v-text-field v-model="gpon.onu" :label="vendor === 'HW' ? checkType === 'SERVICE' ? 'ONU ID' : 'ONU ID/SN ONT' : 'SN ONT'"/>
            </v-col>
          </v-row>
        </div>
      </v-col>
    </v-row>
    <v-dialog
        v-model="dialog"
        fullscreen
        hide-overlay
        transition="dialog-bottom-transition"
        scrollable
    >
      <v-card tile>
        <v-card-title>
          <v-toolbar
              flat
              dark
              color="primary"
          >
            <v-btn
                icon
                dark
                @click="dialog = false"
            >
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <v-toolbar-title>Result</v-toolbar-title>
            <v-spacer></v-spacer>
          </v-toolbar>
        </v-card-title>
        <v-card-text>
          <div v-for="result in results" :key="result.id">
            <div v-html="result.command" v-if="vendor !== 'HW'"></div>
            <div v-html="result.result"></div>
          </div>
        </v-card-text>
      </v-card>
    </v-dialog>
    <v-dialog
        v-model="dialogValidation"
        persistent
        transition="dialog-top-transition"
        max-width="300"
    >
      <v-card>
        <v-card-title class="headline">
          MESSAGE ERROR
        </v-card-title>
        <v-card-text v-text="message"></v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
              color="green darken-1"
              text
              @click="doError"
          >
            Close
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import nmsService from "../service/NmsService"
import regionalService from "../service/RegionalService"
import witelService from "../service/WitelService"
import stoService from "../service/StoService"
import gponService from "../service/GponService"
import configService from "../service/ConfigService"

export default {
  name: "ConfigCheck",
  components: {
    DlgMsg,
    Loading,
  },
  data: () => ({
    checkType: 'UNREG',
    dialog: false,
    selectionType: 'leaf',
    selection: [],
    items: [
        {
          id: 1,
          name: "ALL GPON",
          locked: false,
          children: [],
        }
    ],
    vendors: [],
    vendor: null,
    statusProgress: false,
    results: [],
    dialogValidation: false,
    message: null,
    ipAddress: [],
  }),
  methods: {
    showProgress() {
      window.open('/progress/batch','_blank')
    },
    async doProccess() {
      if (this.selection.length) {
        this.statusProgress = true
        this.items[0].locked = true
        if (this.checkType === 'UNREG') {
          await configService.checkUnreg(this.selection, this.vendor).then((res) => {
            this.getResult(res, res.data.data)
          }).catch(err => {
            console.log(err)
            const {data} = err.response
            this.statusProgress = false
            this.message = `ERROR PROCESS CONFIG: ${data.message}`
            this.dialogValidation = true
            this.items[0].locked = false
          })
        } else if (this.checkType === 'REG') {
          if (this.validation(this.selection)) {
            await configService.checkReg(this.selection, this.vendor).then(res => {
              this.getResult(res, res.data.data)
            }).catch(err => {
              console.log(err)
              const {data} = err.response
              this.statusProgress = false
              this.message = `ERROR PROCESS CONFIG: ${data.message}`
              this.dialogValidation = true
              this.items[0].locked = false
            })
          }
        } else if (this.checkType === 'SERVICE') {
          if (this.validation(this.selection)) {
            await configService.checkService(this.selection, this.vendor).then(res => {
              this.getResult(res, res.data.data)
            }).catch(err => {
              console.log(err)
              const {data} = err.response
              this.statusProgress = false
              this.message = `ERROR PROCESS CONFIG: ${data.message}`
              this.dialogValidation = true
              this.items[0].locked = false
            })
          }
        }
      }
    },
    validation(data) {
      let isValid = true
      for (let i in data) {
        if (data[i].slot == null || data[i].port == null || data[i].slot === '' || data[i].port === '') {
          this.statusProgress = false
          this.items[0].locked = false

          if (data[i].slot == null || data[i].slot === '') {
            this.$refs.dlgMsg.doOpenMsg(`Slot ${data[i].id} Harus Diisi!`)
          } else if (data[i].port == null || data[i].port === '') {
            this.$refs.dlgMsg.doOpenMsg(`Port ${data[i].id} Harus Diisi!`)
          }
          return false
        }
        if ((data[i].onu == null || data[i].onu === '') && this.checkType === 'SERVICE') {
          this.statusProgress = false
          this.items[0].locked = false
          this.$refs.dlgMsg.doOpenMsg(`Onu ${data[i].id} Harus Diisi!`)
          return false
        }
      }
      return isValid
    },
    getResult(res, proccess_id = null) {
      let status = res.data.status
      this.statusProgress = false
      this.items[0].locked = false
      this.results = []
      let results = res.data.data
      if (results && proccess_id == null) {
        for (let i in results) {
          let data = {
            id: i,
            command: this.vendor === 'HW' ? null : '<pre>' + results[i].command + '</pre>',
            result: this.vendor === 'HW' ? '<pre>' + results[i] + '</pre>' : '<pre>' + results[i].result + '</pre>',
          }
          this.results.push(data)
        }
        if (status === "FAILED") {
          this.dialogValidation = true
          this.message = res.data.message
        } else {
          this.dialog = true
        }
      } else {
        this.$refs.dlgMsg.doOpenMsg(res.data.message, null, res.data.data,true)
      }
    },
    doError() {
      this.dialogValidation = false
      if (this.results.length !== 0) {
        this.dialog = true
      }
    },
    async getRegional(vendor) {
      await regionalService.getVendor(vendor).then(async res => {
        let regionals = res.data.data
        this.items[0].children = []
        this.selection = []
        for (let regional of regionals) {
          if (regional.witels.length > 0) {
            let reg = {
              id: regional.id,
              name: regional.nama,
              children: await this.getWitel(regional.witels)
            }
            this.items[0].children.push(reg)
            this.items[0].children.sort(regionalService.sortOrder("name"))
          }
        }
        this.statusProgress = false
        this.items[0].locked = false
      })
    },
    async getWitel(witelsParam) {
      let witels = []
        for (let witel of witelsParam) {
          if (witel.stos.length > 0) {
            let wtl = {
              id: witel.id,
              name: witel.nama,
              children: await this.getSto(witel.stos),
            }
            witels.push(wtl)
            witels.sort(witelService.sortOrder("name"))
          }
        }
      return Promise.resolve(witels)
    },
    async getSto(stosParam) {
      let stos = []
      for (let sto of stosParam) {
        if (sto.gpons.length > 0) {
          let stoObj = {
            id: sto.id + sto.alias,
            name: sto.nama,
            children: await this.getGpon(sto.gpons),
          }
          stos.push(stoObj)
          stos.sort(stoService.sortOrder("name"));
        }
      }
      return Promise.resolve(stos)
    },
    getGpon(gponsParam) {
      let gpons = []
      for (let gpon of gponsParam) {
        let gponObj = {
          id: gpon.ip_address,
          name: `${gpon.hostname}(${gpon.ip_address})`,
          slot: null,
          port: null,
          onu: null
        }
        gpons.push(gponObj)
        gpons.sort(gponService.sortOrder("name"))
      }
      return Promise.resolve(gpons)
    },
    async doChangeVendor() {
      this.statusProgress = true
      this.items[0].locked = true
      await this.getRegional(this.vendor)
    },
    async retrieveVendor() {
      this.statusProgress = true
      await nmsService.getVendor().then(res => {
        this.vendors = res.data.data
      })
      this.statusProgress = false
    },
  },
  created() {
    this.retrieveVendor()
  },
}
</script>

<style scoped>

</style>